# -*- coding: ISO-8859-15 -*-
# (C) Copyright 2005 Nuxeo SARL <http://nuxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: zopecal.py 24305 2005-06-22 14:39:11Z lregebro $

from base64 import encodestring, decodestring
import urllib
import random
random.seed()

from zExceptions import Unauthorized
from AccessControl.SecurityInfo import ClassSecurityInfo
from OFS.PropertyManager import PropertyManager
from App.class_init import default__class_init__ as InitializeClass
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Products.PageTemplates.ZopePageTemplate import manage_addPageTemplate

from Products.PluggableAuthService.plugins.BasePlugin import BasePlugin
from Products.PluggableAuthService.utils import classImplements
from Products.PluggableAuthService.interfaces.plugins import \
        IExtractionPlugin, IChallengePlugin, IAuthenticationPlugin, \
        ICredentialsResetPlugin


manage_addKniggetChallengeForm = PageTemplateFile(
    'zmi/manage_addKniggetChallengeForm', globals())


def addKniggetChallenge( dispatcher
                       , id
                       , title=None
                       , REQUEST=None
                       ):
    """ Add a KniggetChallenge to a Pluggable Auth Service. """
    sp = KniggetChallenge(id, title)
    dispatcher._setObject(sp.getId(), sp)

    if REQUEST is not None:
        REQUEST['RESPONSE'].redirect( '%s/manage_workspace'
                                      '?manage_tabs_message='
                                      'KniggetChallenge+added.'
                                    % dispatcher.absolute_url() )


class KniggetChallenge(PropertyManager, BasePlugin):
    """ Multi-plugin for managing details of CAS Authentication. """

    meta_type = 'Knigget Challenge'
    security = ClassSecurityInfo()
    protocol = "http" # The PAS challenge 'protocol' we use.

    _properties = ( { 'id'    : 'title'
                    , 'label' : 'Title'
                    , 'type'  : 'string'
                    , 'mode'  : 'w'
                    }
                  , {'id'     : 'challenges',
                     'type'   : 'lines',
                     'label'  : 'Challenges',
                     'mode'   : 'w',
                    }
                  )

    manage_options = ( BasePlugin.manage_options[:1] + \
                       PropertyManager.manage_options + \
                       BasePlugin.manage_options[2:]
                     )

    challenges = ["401! You are English types-a!", 
                  "Mind your own login!", 
                  "You don't login here, English pig-dogs!", 
                  "Go and boil your password, sons of a silly person.", 
                  "I blow my nose at you, so-called Login King, you and all your silly English  k-nnnnniggets.", 
                  "Thpppppt! Thppt! 401!", 
                  "I don't wanna talk to you no more, you empty passworded animal food trough wiper!", 
                  "I 401 in your general direction!", 
                  "Your mother was a hamster and you don't have a password!",
                 ]
                         
    def __init__(self, id, title=None):
        self._setId(id)
        self.title = title

            
    security.declarePrivate('challenge')
    def challenge(self, request, response, **kw):
        """ Challenge the user for credentials. """
        size = len(self.challenges)
        i = random.randint(0, size-1)
        response.setStatus(401)
        response._has_challenged = True
        raise Unauthorized, self.challenges[i]


classImplements(KniggetChallenge, IChallengePlugin)

InitializeClass(KniggetChallenge)

